package cn.ibizlab.businesscentral.core.odoo_account.client;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.web.bind.annotation.*;
import cn.ibizlab.businesscentral.core.odoo_account.domain.Account_fiscal_position;
import cn.ibizlab.businesscentral.core.odoo_account.filter.Account_fiscal_positionSearchContext;
import org.springframework.cloud.openfeign.FeignClient;

/**
 * 实体[account_fiscal_position] 服务对象接口
 */
@FeignClient(value = "${ibiz.ref.service.odoo-account:odoo-account}", contextId = "account-fiscal-position", fallback = account_fiscal_positionFallback.class)
public interface account_fiscal_positionFeignClient {

    @RequestMapping(method = RequestMethod.PUT, value = "/account_fiscal_positions/{id}")
    Account_fiscal_position update(@PathVariable("id") Long id,@RequestBody Account_fiscal_position account_fiscal_position);

    @RequestMapping(method = RequestMethod.PUT, value = "/account_fiscal_positions/batch")
    Boolean updateBatch(@RequestBody List<Account_fiscal_position> account_fiscal_positions);




    @RequestMapping(method = RequestMethod.POST, value = "/account_fiscal_positions/search")
    Page<Account_fiscal_position> search(@RequestBody Account_fiscal_positionSearchContext context);


    @RequestMapping(method = RequestMethod.DELETE, value = "/account_fiscal_positions/{id}")
    Boolean remove(@PathVariable("id") Long id);

    @RequestMapping(method = RequestMethod.DELETE, value = "/account_fiscal_positions/batch}")
    Boolean removeBatch(@RequestBody Collection<Long> idList);


    @RequestMapping(method = RequestMethod.GET, value = "/account_fiscal_positions/{id}")
    Account_fiscal_position get(@PathVariable("id") Long id);



    @RequestMapping(method = RequestMethod.POST, value = "/account_fiscal_positions")
    Account_fiscal_position create(@RequestBody Account_fiscal_position account_fiscal_position);

    @RequestMapping(method = RequestMethod.POST, value = "/account_fiscal_positions/batch")
    Boolean createBatch(@RequestBody List<Account_fiscal_position> account_fiscal_positions);



    @RequestMapping(method = RequestMethod.GET, value = "/account_fiscal_positions/select")
    Page<Account_fiscal_position> select();


}
