package cn.ibizlab.businesscentral.core.odoo_account.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.odoo_account.domain.Account_invoice_line;
import cn.ibizlab.businesscentral.core.odoo_account.filter.Account_invoice_lineSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[Account_invoice_line] 服务对象接口
 */
public interface IAccount_invoice_lineService extends IService<Account_invoice_line>{

    boolean create(Account_invoice_line et) ;
    void createBatch(List<Account_invoice_line> list) ;
    boolean update(Account_invoice_line et) ;
    void updateBatch(List<Account_invoice_line> list) ;
    boolean remove(Long key) ;
    void removeBatch(Collection<Long> idList) ;
    Account_invoice_line get(Long key) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<Account_invoice_line> getAccountInvoiceLineByIds(List<String> ids) ;
    List<Account_invoice_line> getAccountInvoiceLineByEntities(List<Account_invoice_line> entities) ;
}


