package cn.ibizlab.businesscentral.core.odoo_product.client;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.web.bind.annotation.*;
import cn.ibizlab.businesscentral.core.odoo_product.domain.Product_category;
import cn.ibizlab.businesscentral.core.odoo_product.filter.Product_categorySearchContext;
import org.springframework.cloud.openfeign.FeignClient;

/**
 * 实体[product_category] 服务对象接口
 */
@FeignClient(value = "${ibiz.ref.service.odoo-product:odoo-product}", contextId = "product-category", fallback = product_categoryFallback.class)
public interface product_categoryFeignClient {

    @RequestMapping(method = RequestMethod.PUT, value = "/product_categories/{id}")
    Product_category update(@PathVariable("id") Long id,@RequestBody Product_category product_category);

    @RequestMapping(method = RequestMethod.PUT, value = "/product_categories/batch")
    Boolean updateBatch(@RequestBody List<Product_category> product_categories);



    @RequestMapping(method = RequestMethod.POST, value = "/product_categories")
    Product_category create(@RequestBody Product_category product_category);

    @RequestMapping(method = RequestMethod.POST, value = "/product_categories/batch")
    Boolean createBatch(@RequestBody List<Product_category> product_categories);



    @RequestMapping(method = RequestMethod.DELETE, value = "/product_categories/{id}")
    Boolean remove(@PathVariable("id") Long id);

    @RequestMapping(method = RequestMethod.DELETE, value = "/product_categories/batch}")
    Boolean removeBatch(@RequestBody Collection<Long> idList);


    @RequestMapping(method = RequestMethod.GET, value = "/product_categories/{id}")
    Product_category get(@PathVariable("id") Long id);



    @RequestMapping(method = RequestMethod.POST, value = "/product_categories/search")
    Page<Product_category> search(@RequestBody Product_categorySearchContext context);



    @RequestMapping(method = RequestMethod.GET, value = "/product_categories/select")
    Page<Product_category> select();


}
