package cn.ibizlab.businesscentral.core.odoo_repair.client;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.web.bind.annotation.*;
import cn.ibizlab.businesscentral.core.odoo_repair.domain.Repair_cancel;
import cn.ibizlab.businesscentral.core.odoo_repair.filter.Repair_cancelSearchContext;
import org.springframework.cloud.openfeign.FeignClient;

/**
 * 实体[repair_cancel] 服务对象接口
 */
@FeignClient(value = "${ibiz.ref.service.odoo-repair:odoo-repair}", contextId = "repair-cancel", fallback = repair_cancelFallback.class)
public interface repair_cancelFeignClient {

    @RequestMapping(method = RequestMethod.POST, value = "/repair_cancels")
    Repair_cancel create(@RequestBody Repair_cancel repair_cancel);

    @RequestMapping(method = RequestMethod.POST, value = "/repair_cancels/batch")
    Boolean createBatch(@RequestBody List<Repair_cancel> repair_cancels);




    @RequestMapping(method = RequestMethod.POST, value = "/repair_cancels/search")
    Page<Repair_cancel> search(@RequestBody Repair_cancelSearchContext context);


    @RequestMapping(method = RequestMethod.GET, value = "/repair_cancels/{id}")
    Repair_cancel get(@PathVariable("id") Long id);


    @RequestMapping(method = RequestMethod.PUT, value = "/repair_cancels/{id}")
    Repair_cancel update(@PathVariable("id") Long id,@RequestBody Repair_cancel repair_cancel);

    @RequestMapping(method = RequestMethod.PUT, value = "/repair_cancels/batch")
    Boolean updateBatch(@RequestBody List<Repair_cancel> repair_cancels);



    @RequestMapping(method = RequestMethod.DELETE, value = "/repair_cancels/{id}")
    Boolean remove(@PathVariable("id") Long id);

    @RequestMapping(method = RequestMethod.DELETE, value = "/repair_cancels/batch}")
    Boolean removeBatch(@RequestBody Collection<Long> idList);



    @RequestMapping(method = RequestMethod.GET, value = "/repair_cancels/select")
    Page<Repair_cancel> select();


}
