package cn.ibizlab.businesscentral.core.odoo_stock.client;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.web.bind.annotation.*;
import cn.ibizlab.businesscentral.core.odoo_stock.domain.Stock_change_product_qty;
import cn.ibizlab.businesscentral.core.odoo_stock.filter.Stock_change_product_qtySearchContext;
import org.springframework.cloud.openfeign.FeignClient;

/**
 * 实体[stock_change_product_qty] 服务对象接口
 */
@FeignClient(value = "${ibiz.ref.service.odoo-stock:odoo-stock}", contextId = "stock-change-product-qty", fallback = stock_change_product_qtyFallback.class)
public interface stock_change_product_qtyFeignClient {



    @RequestMapping(method = RequestMethod.PUT, value = "/stock_change_product_qties/{id}")
    Stock_change_product_qty update(@PathVariable("id") Long id,@RequestBody Stock_change_product_qty stock_change_product_qty);

    @RequestMapping(method = RequestMethod.PUT, value = "/stock_change_product_qties/batch")
    Boolean updateBatch(@RequestBody List<Stock_change_product_qty> stock_change_product_qties);


    @RequestMapping(method = RequestMethod.DELETE, value = "/stock_change_product_qties/{id}")
    Boolean remove(@PathVariable("id") Long id);

    @RequestMapping(method = RequestMethod.DELETE, value = "/stock_change_product_qties/batch}")
    Boolean removeBatch(@RequestBody Collection<Long> idList);



    @RequestMapping(method = RequestMethod.GET, value = "/stock_change_product_qties/{id}")
    Stock_change_product_qty get(@PathVariable("id") Long id);



    @RequestMapping(method = RequestMethod.POST, value = "/stock_change_product_qties/search")
    Page<Stock_change_product_qty> search(@RequestBody Stock_change_product_qtySearchContext context);


    @RequestMapping(method = RequestMethod.POST, value = "/stock_change_product_qties")
    Stock_change_product_qty create(@RequestBody Stock_change_product_qty stock_change_product_qty);

    @RequestMapping(method = RequestMethod.POST, value = "/stock_change_product_qties/batch")
    Boolean createBatch(@RequestBody List<Stock_change_product_qty> stock_change_product_qties);


    @RequestMapping(method = RequestMethod.GET, value = "/stock_change_product_qties/select")
    Page<Stock_change_product_qty> select();


}
