package cn.ibizlab.businesscentral.core.odoo_survey.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.odoo_survey.domain.Survey_mail_compose_message;
import cn.ibizlab.businesscentral.core.odoo_survey.filter.Survey_mail_compose_messageSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[Survey_mail_compose_message] 服务对象接口
 */
public interface ISurvey_mail_compose_messageService extends IService<Survey_mail_compose_message>{

    boolean create(Survey_mail_compose_message et) ;
    void createBatch(List<Survey_mail_compose_message> list) ;
    boolean update(Survey_mail_compose_message et) ;
    void updateBatch(List<Survey_mail_compose_message> list) ;
    boolean remove(Long key) ;
    void removeBatch(Collection<Long> idList) ;
    Survey_mail_compose_message get(Long key) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<Survey_mail_compose_message> getSurveyMailComposeMessageByIds(List<String> ids) ;
    List<Survey_mail_compose_message> getSurveyMailComposeMessageByEntities(List<Survey_mail_compose_message> entities) ;
}


